# terraform-auto-doc

This program takes a terraform path and a template and can generate automatic documentation in markdown format.
TODO update docs
It also produces links in the GitLab format.
### Usage

    Usage of ./terraform-auto-doc:
      -action string
            The Action to perform. [VarsTable OutputsTable ManagedResourcesTable ProvidersTable RequirementsTable DataSourcesTable RenderTemplate UpdateFile]
      -modulePath string
            The path of the module relative to the repository
      -path string
            The path to the Terraform Module to inspect.
      -repoURL string
            The URL path used as a prefix for links
      -templatePath string
            The path to the template to render
      -outputPath string 
            The path to the file to update only used in the UpdateFile action

You can also use this outside of template to render markdown tables for various Terraform object types.


### Update File action 
using:  
`-path <terraform_directory_path> -action UpdateFile -outputPath <output_filepath> -templatePath <template_filepath>`    
To manually specifiy where the update file logic will generate the outputs into add these two lines where you want the code. If a file does not see these lines it will add the generated outputs to the end of a file.   
`<!-- generation by terraform auto doc -->`  

`<!-- generation by terraform auto doc end -->`  

All code placed between these comments on a .md format file will be replaced with a generation

### Code Position Links
Location string links will be generated by using a combination of repoURL and modulepath are blank it will assume the file is in the same directory   
`-repoURL <string> -modulePath <string>`  

RepoURL and module path set: `repoURL/modulePath/<filename>#<linenumber>`  
Both blank: `<filename>#<linenumber>`  
Just module path: `/modulePath/<filename>#<linenumber>`  
Just repoURL: `repoURL/<filename>#<Linenumber>`  